﻿using System;

// Abstract base class for products
abstract class AbstractProductA
{
    public abstract void operationA();
}

// Concrete product class A1
class ConcreteProductA1 : AbstractProductA
{
    public override void operationA()
    {
        Console.WriteLine("Concrete Product A1 operation A");
    }
}

// Concrete product class A2
class ConcreteProductA2 : AbstractProductA
{
    public override void operationA()
    {
        Console.WriteLine("Concrete Product A2 operation A");
    }
}

// Abstract base class for products
abstract class AbstractProductB
{
    public abstract void operationB();
}

// Concrete product class B1
class ConcreteProductB1 : AbstractProductB
{
    public override void operationB()
    {
        Console.WriteLine("Concrete Product B1 operation B");
    }
}

// Concrete product class B2
class ConcreteProductB2 : AbstractProductB
{
    public override void operationB()
    {
        Console.WriteLine("Concrete Product B2 operation B");
    }
}

// Abstract factory class
abstract class AbstractFactory
{
    public abstract AbstractProductA createProductA();
    public abstract AbstractProductB createProductB();
}

// Concrete factory class 1
class ConcreteFactory1 : AbstractFactory
{
    public override AbstractProductA createProductA()
    {
        return new ConcreteProductA1();
    }
    public override AbstractProductB createProductB()
    {
        return new ConcreteProductB1();
    }
}

// Concrete factory class 2
class ConcreteFactory2 : AbstractFactory
{
    public override AbstractProductA createProductA()
    {
        return new ConcreteProductA2();
    }
    public override AbstractProductB createProductB()
    {
        return new ConcreteProductB2();
    }
}

class Program
{
    static void Main()
    {
        AbstractFactory factory = new ConcreteFactory1();
        AbstractProductA productA = factory.createProductA();
        AbstractProductB productB = factory.createProductB();
        productA.operationA();
        productB.operationB();
        factory = new ConcreteFactory2();
        productA = factory.createProductA();
        productB = factory.createProductB();
        productA.operationA();
        productB.operationB();
    }
}